; GameBase v1.1 Inno Setup Installation Script File
; (c) 2004 James Burrows
; excludes DAO 3.6 and Jet 4.0 and vb runtimes

[Setup]

AppName=GameBase
AppVerName=GameBase v1.1
AppPublisher=BU22
AppPublisherURL=http://www.bu22.com/
AppSupportURL=http://www.bu22.com/
AppUpdatesURL=http://www.bu22.com/
DefaultDirName={pf}\GameBase
DefaultGroupName=BU22
AllowNoIcons=yes
LicenseFile=License.txt

[Tasks]

Name: "desktopicon"; Description: "Create a &desktop icon"; GroupDescription: "Additional icons:"; MinVersion: 4,4
Name: "quicklaunchicon"; Description: "Create a &Quick Launch icon"; GroupDescription: "Additional icons:"; MinVersion: 4,4; Flags: unchecked

[Files]

;Windows System Folder (DLL Register)
Source: "winsysreg\COMDLG32.OCX"; DestDir: "{sys}"; CopyMode: alwaysskipifsameorolder; Flags: restartreplace sharedfile regserver
Source: "winsysreg\MSCOMCTL.OCX"; DestDir: "{sys}"; CopyMode: alwaysskipifsameorolder; Flags: restartreplace sharedfile regserver
Source: "winsysreg\TABCTL32.OCX"; DestDir: "{sys}"; CopyMode: alwaysskipifsameorolder; Flags: restartreplace sharedfile regserver
Source: "winsysreg\mswinsck.ocx"; DestDir: "{sys}"; CopyMode: alwaysskipifsameorolder; Flags: restartreplace sharedfile regserver

;App Folder (DLL Register)
Source: "PNGlib.dll"; DestDir: "{app}"; CopyMode: alwaysoverwrite; Flags: sharedfile regserver
Source: "GBFuncs.dll"; DestDir: "{app}"; CopyMode: alwaysoverwrite; Flags: sharedfile regserver
Source: "GBSql.dll"; DestDir: "{app}"; CopyMode: alwaysoverwrite; Flags: sharedfile regserver
Source: "Gemus.dll"; DestDir: "{app}"; CopyMode: alwaysoverwrite; Flags: sharedfile regserver

;App Folder (NON Register)
Source: "GameBase.exe"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "GBToolbox.exe"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "LHA.EXE"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "STARLYNX.EXE"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "STARZIP.EXE"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "BMP2GIF.EXE"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "BMP2PNG.EXE"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "unzip32.dll"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "zlib.dll"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "Empty.mdb"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "GBText.ini"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "GemusText.ini"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "GameBase.ini"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "History.txt"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "License.txt"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "gemus.dat"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "vbzip10.dll"; DestDir: "{app}"; CopyMode: alwaysoverwrite

;scripts folder
Source: "Scripts\default.txt"; DestDir: "{app}\Scripts"; CopyMode: alwaysoverwrite
Source: "Scripts\CCS64_v20b_DOS.txt"; DestDir: "{app}\Scripts"; CopyMode: alwaysoverwrite
Source: "Scripts\CCS64_v20b_Win32.txt"; DestDir: "{app}\Scripts"; CopyMode: alwaysoverwrite
Source: "Scripts\WinVICE.txt"; DestDir: "{app}\Scripts"; CopyMode: alwaysoverwrite
Source: "Scripts\CCS64_v109.txt"; DestDir: "{app}\Scripts"; CopyMode: alwaysoverwrite

;Documentation Folder
Source: "docs\create.htm"; DestDir: "{app}\Docs"; CopyMode: alwaysoverwrite
Source: "docs\faq.htm"; DestDir: "{app}\Docs"; CopyMode: alwaysoverwrite
Source: "docs\gemus.htm"; DestDir: "{app}\Docs"; CopyMode: alwaysoverwrite
Source: "docs\gemusdat.htm"; DestDir: "{app}\Docs"; CopyMode: alwaysoverwrite
Source: "docs\index.htm"; DestDir: "{app}\Docs"; CopyMode: alwaysoverwrite
Source: "docs\pictures.htm"; DestDir: "{app}\Docs"; CopyMode: alwaysoverwrite
Source: "docs\started.htm"; DestDir: "{app}\Docs"; CopyMode: alwaysoverwrite
Source: "docs\license.htm"; DestDir: "{app}\Docs"; CopyMode: alwaysoverwrite

;Documentation Images
Source: "docs\images\lv_gameandsid.gif"; DestDir: "{app}\Docs\Images"; CopyMode: alwaysoverwrite
Source: "docs\images\lv_justgame.gif"; DestDir: "{app}\Docs\Images"; CopyMode: alwaysoverwrite
Source: "docs\images\lv_justsid.gif"; DestDir: "{app}\Docs\Images"; CopyMode: alwaysoverwrite
Source: "docs\images\lv_sidonly.gif"; DestDir: "{app}\Docs\Images"; CopyMode: alwaysoverwrite

[INI]

Filename: "{app}\GameBase.url"; Section: "InternetShortcut"; Key: "URL"; String: "http://www.bu22.com/"

[Registry]

Root: HKLM; Subkey: "Software\GB64"; Flags: uninsdeletekeyifempty
Root: HKLM; Subkey: "Software\GB64\GameBase"; Flags: uninsdeletekey
Root: HKLM; Subkey: "Software\GB64\Gemus"; Flags: uninsdeletekeyifempty
Root: HKLM; Subkey: "Software\GB64\GBToolbox"; Flags: uninsdeletekey

[Icons]

Name: "{group}\The GameBase Frontend"; Filename: "{app}\GameBase.exe"
Name: "{group}\The GameBase Toolbox"; Filename: "{app}\GBToolbox.exe"
Name: "{group}\GameBase Documentation"; Filename: "{app}\Docs\index.htm"
Name: "{group}\GameBase Web Site"; Filename: "{app}\GameBase.url"
Name: "{userdesktop}\GameBase"; Filename: "{app}\GameBase.exe"; MinVersion: 4,4; Tasks: desktopicon
Name: "{userdesktop}\GBToolbox"; Filename: "{app}\GBToolbox.exe"; MinVersion: 4,4; Tasks: desktopicon
Name: "{userappdata}\Microsoft\Internet Explorer\Quick Launch\GameBase"; Filename: "{app}\GameBase.exe"; MinVersion: 4,4; Tasks: quicklaunchicon
Name: "{userappdata}\Microsoft\Internet Explorer\Quick Launch\GBToolbox"; Filename: "{app}\GBToolbox.exe"; MinVersion: 4,4; Tasks: quicklaunchicon

[UninstallDelete]

Type: files; Name: "{app}\GameBase.url"


