VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "csExtract"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private FileContents As FileListBox
Private Func As csFunctions
Private Const FillLine As String = "--------------------------------"
Private Const EmulatorPattern As String = "*.d64;*.t64;*.prg;*.p00;*.p01;*.p02;*.p03;*.p04;*.p05;*.p06;*.p07;*.p08;*.p09"
Private Pass As Integer
Private strFileInfo As String
Private strFilename As String
Private Enum eRecursiveState
    GotFile
    KeepGoing
    NotValid
End Enum
Private State As eRecursiveState
Private PassDir As String
Private FileCount As Long
Private From As String
Private gbDB As String
Private dbArchive As Database
Private rsArchive As Recordset
Private ItemInList As Long
Private ReZipDir As String
Private ArchiveFile As String
Private Found As Boolean
Private TempString As String
Private TempFlag As Boolean
Private GameIDToFind As Long
Private CommandCom As String
Private gbAppPath As String
Private RawFile As String
Private TempFile As String
Private TempPath As String
Private WinZip As String
Private ZipCode As Integer
Private f As Integer
Private FileLen As Long
Private DestFile As String

'API
Private Type SHFILEOPSTRUCT
        hwnd As Long
        wFunc As Long
        pFrom As String
        pTo As String
        fFlags As Integer
        fAnyOperationsAborted As Long
        hNameMappings As Long
        lpszProgressTitle As String '  only used if FOF_SIMPLEPROGRESS
End Type
Private Type PROCESS_INFORMATION
        hProcess As Long
        hThread As Long
        dwProcessId As Long
        dwThreadId As Long
End Type
Private Type STARTUPINFO
        cb As Long
        lpReserved As String
        lpDesktop As String
        lpTitle As String
        dwX As Long
        dwY As Long
        dwXSize As Long
        dwYSize As Long
        dwXCountChars As Long
        dwYCountChars As Long
        dwFillAttribute As Long
        dwFlags As Long
        wShowWindow As Integer
        cbReserved2 As Integer
        lpReserved2 As Long
        hStdInput As Long
        hStdOutput As Long
        hStdError As Long
End Type
Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Private Declare Function SHFileOperation Lib "shell32.dll" Alias " SHFileOperationA" (lpFileOp As SHFILEOPSTRUCT) As Long
Private Declare Function CreateProcess Lib "kernel32" Alias "CreateProcessA" (ByVal lpApplicationName As String, ByVal lpCommandLine As String, lpProcessAttributes As Any, lpThreadAttributes As Any, ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, lpEnvironment As Any, ByVal lpCurrentDriectory As String, lpStartupInfo As STARTUPINFO, lpProcessInformation As PROCESS_INFORMATION) As Long
Private Const STARTF_USESHOWWINDOW = &H1
Private Const SW_HIDE = 0
Private Const SW_MINIMIZE = 6
Private Const FOF_NOCONFIRMATION = &H10
Private Const FOF_RENAMEONCOLLISION = &H8
Private Const FOF_SILENT = &H4
Private Const NORMAL_PRIORITY_CLASS = &H20
Private Const INFINITE = &HFFFF


Public Function Extract(ByVal AppPath As String, ByVal FileToExtract As String, ByVal DatabaseFile As String, ByVal CurrGameDIR As String, ReturnFilename As String, ReturnFailInfo As String, ByVal FromProgram As String, ByVal WinzipPath As String, Optional ByVal GameID As Long) As Boolean

    'call the recursive routine to extract the file until valid or not valid
    
    Dim JustFile As String
    Dim JustPath As String
    Dim CGWB As String
    Dim ret As Boolean
    
    'set initial variables for the recursive routine
    Pass = 0
    strFileInfo = ""
    strFilename = ""
    From = FromProgram
    gbDB = DatabaseFile
    GameIDToFind = GameID
    State = KeepGoing
    gbAppPath = AppPath
    WinZip = WinzipPath
    
    'set up currgame folder and copy file into there for working on
    Func.GetFileAndPath FileToExtract, JustFile, JustFile
    ArchiveFile = JustFile
    Func.DeletePathSilent CurrGameDIR
    MkDir CurrGameDIR
    CGWB = CurrGameDIR
    If Right$(CGWB, 1) <> "\" Then CGWB = CGWB & "\"
    ReZipDir = CGWB & "ReZip\"
    FileCopy FileToExtract, CGWB & JustFile
    
    'extract the game
    ExtractAgain CurrGameDIR
    
    'return the filename and info string
    Extract = IIf((State = GotFile), True, False)
    ReturnFilename = strFilename
    ReturnFailInfo = strFileInfo

End Function


Private Sub ExtractAgain(ByVal TestPath As String)



    '******************************************************************************
    '* recursive routine to get the valid filename for shelling into the emulator *
    '******************************************************************************
    
    
    On Error GoTo Err_Handler
    
       
    If State = KeepGoing Then 'valid/invalid file not found yet
    
    
    
        'increase Directory Level
        Pass = Pass + 1
        PassDir = "P" & Trim$(Pass)
        
        
        
        With FileContents
        
        
        
        
            '**********************************************
            '* FIRST TEST IF FILES IN DIRECTORY ARE VALID *
            '**********************************************
            
            
            
            
            .Path = TestPath
            .Pattern = EmulatorPattern
            .Refresh
            
            If .ListCount = 1 Then 'one valid file only
                strFilename = ReZipDir & .List(0)
                strFileInfo = ""
                MoveToRezipFolder TestPath
                State = GotFile
                GoTo NextPass
                
            ElseIf .ListCount > 1 Then 'more than one valid file
            
                'has default valid file been set in gamebase64.mdb?
                
                If From = "gamebase64" Then 'no check for Quick64 or gamebase64 game selector screen
                
                    Set dbArchive = OpenDatabase(gbDB)
                    Set rsArchive = dbArchive.OpenRecordset("SELECT * FROM Archive WHERE GA_ID = " & GameIDToFind, dbOpenDynaset)
                    Found = False
                    If Not rsArchive.EOF Then
                        'check the found file exists in the folder - if not then remove the record
                        rsArchive.MoveFirst
                        TempString = UCase(rsArchive.Fields("FileToRun"))
                        For ItemInList = 0 To .ListCount - 1
                            If UCase(.List(ItemInList)) = TempString Then
                                Found = True
                                Exit For
                            End If
                        Next ItemInList
                        If Found = False Then
                            rsArchive.Delete
                        End If
                    End If
                    rsArchive.Close
                    If Found = True Then
                        strFilename = ReZipDir & .List(ItemInList)
                        strFileInfo = ""
                        MoveToRezipFolder TestPath
                        State = GotFile
                        Set rsArchive = Nothing
                        Set dbArchive = Nothing
                        GoTo NextPass
                    Else
                        'show form to pick default file
                        Load frmGB64Main
                        With frmGB64Main.lstFiles
                            For ItemInList = 0 To FileContents.ListCount - 1
                                .AddItem FileContents.List(ItemInList)
                            Next ItemInList
                            .ListIndex = 0
                        End With
                        frmGB64Main.Show 1
                        'cancel was pressed
                        If g_strDefaultFile = "" Then
                            strFilename = ""
                            strFileInfo = "You need to specify a default file to load into the emulators before you can run this game." & vbCrLf & FillLine & FilesInTempDIR(TestPath) & FillLine
                            State = NotValid
                            Set rsArchive = Nothing
                            Set dbArchive = Nothing
                            GoTo NextPass
                        Else 'save the new default file to the database "Archive" table
                            Set rsArchive = dbArchive.OpenRecordset("Archive", dbOpenTable)
                            With rsArchive
                                .AddNew
                                .Fields("GA_ID") = GameIDToFind
                                .Fields("FileToRun") = g_strDefaultFile
                                .Update
                                .Close
                            End With
                            strFilename = ReZipDir & g_strDefaultFile
                            strFileInfo = ""
                            MoveToRezipFolder TestPath
                            State = GotFile
                            Set rsArchive = Nothing
                            Set dbArchive = Nothing
                            GoTo NextPass
                        End If
                    End If
                    Set rsArchive = Nothing
                    Set dbArchive = Nothing
                    
                Else 'Quick64 or gamebase64 Game Selector screen
                
                    'show form to pick default file
                    Load frmGB64Main
                    With frmGB64Main.lstFiles
                        For ItemInList = 0 To FileContents.ListCount - 1
                            .AddItem FileContents.List(ItemInList)
                        Next ItemInList
                        .ListIndex = 0
                    End With
                    frmGB64Main.Show 1
                    'cancel was pressed
                    If g_strDefaultFile = "" Then
                        strFilename = ""
                        strFileInfo = "You need to specify a default file to load into the emulators before you can run this game." & vbCrLf & FillLine & FilesInTempDIR(TestPath) & FillLine
                        State = NotValid
                        GoTo NextPass
                    Else 'save the new default file to the database "Archive" table
                        strFilename = ReZipDir & g_strDefaultFile
                        strFileInfo = ""
                        MoveToRezipFolder TestPath
                        State = GotFile
                        GoTo NextPass
                    End If
                    
                End If
                
            End If
            
            
            
            
            '********************************************************************
            '* NO VALID FILES IN DIRECTORY - TEST WHAT KIND OF FILES ARE THERE! *
            '********************************************************************
            
            
            
            
            '=========
            'ZIP FILES
            '=========
            
            .Pattern = "*.zip"
            .Refresh
            If .ListCount > 0 Then 'VALID if 1 or Pick First Zip file
                MkDir TestPath & "\" & PassDir
                g_blnZipError = False
                UnzipToTempDIR TestPath & "\" & PassDir, TestPath & "\" & .List(0)
                If g_blnZipError = True Then
                    strFilename = ""
                    strFileInfo = "There was an error unzipping the file:" & vbCrLf & vbCrLf & TestPath & "\" & .List(0) & vbCrLf & vbCrLf & "The file is possibly corrupt."
                    State = NotValid
                    GoTo NextPass
                Else
                    ExtractAgain TestPath & "\" & PassDir
                    GoTo NextPass
                End If
            End If
            
            '=============
            'LHA/LZH FILES
            '=============
            
            .Pattern = "*.lha;*.lzh" 'VALID if 1 or Pick First lha/lzh file
            .Refresh
            If .ListCount > 0 Then
                If Not Func.FileExists("lha.exe", False, "") Then
                    strFilename = ""
                    strFileInfo = "To extract this File you need to put the file LHA.EXE into a folder on the PATH environment variable."
                    State = NotValid
                    GoTo NextPass
                End If
                MkDir TestPath & "\" & PassDir
                UnLha TestPath, .List(0), TestPath & "\" & PassDir
                ExtractAgain TestPath & "\" & PassDir
                GoTo NextPass
            End If
            
            '========
            'GZ FILES
            '========

            .Pattern = "*.gz" 'VALID if 1 or Pick First gz file
            .Refresh
            If .ListCount > 0 Then
                If Not Func.FileExists(WinZip, False, "") Then
                    If Not Func.FileExists("gunzip.exe", False, "") Then
                        strFilename = ""
                        strFileInfo = "To extract this File you need to put the file GUNZIP.EXE into a folder on the PATH environment variable.  You can also use Winzip to extract these files if you set it's path in 'Options...'."
                        State = NotValid
                        GoTo NextPass
                    ElseIf InStr(.List(0), "+") > 0 Then
                        strFilename = ""
                        strFileInfo = "To extract this File you need to set your WINZIP path in 'Options...'.  This is needed because GUNZIP.EXE cannot extract files with '+' in the archived filename."
                        State = NotValid
                        GoTo NextPass
                    End If
                    MkDir TestPath & "\" & PassDir
                    UnGZ TestPath, .List(0), TestPath & "\" & PassDir
                    ExtractAgain TestPath & "\" & PassDir
                    GoTo NextPass
                Else
                    MkDir TestPath & "\" & PassDir
                    WinzipExtract TestPath, .List(0), TestPath & "\" & PassDir
                    ExtractAgain TestPath & "\" & PassDir
                    GoTo NextPass
                End If
            End If
            
            '==============
            'ZIPCODED FILES
            '==============

            .Pattern = "1!*.*"
            .Refresh
            If .ListCount > 0 Then
                If Func.FileExists("zip2d64.exe", False, "") Then
                    MkDir TestPath & "\" & PassDir
                    For ZipCode = 0 To .ListCount - 1
                        TempFile = Func.Long2Short(TestPath & "\" & .List(ZipCode))
                        Func.GetFileAndPath TempFile, TempPath, RawFile
                        RawFile = Right(RawFile, Len(RawFile) - 2)
                        DestFile = Right(.List(ZipCode), Len(.List(ZipCode)) - 2)
                        Zip2D64 TestPath & "\" & PassDir, TestPath, RawFile, DestFile & ".d64"
                    Next ZipCode
                    ExtractAgain TestPath & "\" & PassDir
                    GoTo NextPass
                Else
                    strFilename = ""
                    strFileInfo = "To extract this File you need to put the file ZIP2D64.EXE into a folder on the PATH environment variable."
                    State = NotValid
                    GoTo NextPass
                End If
            End If
            
            '==========
            'LYNX FILES
            '==========

            .Pattern = "*.lnx"
            .Refresh
            If .ListCount > 0 Then
                If Func.FileExists("starlynx.exe", False, "") Then
                    MkDir TestPath & "\" & PassDir
                    For ZipCode = 0 To .ListCount - 1
                        TempFile = Func.Long2Short(TestPath & "\" & .List(ZipCode))
                        Func.GetFileAndPath TempFile, TempPath, RawFile
                        UnLynx TestPath & "\" & PassDir, TestPath, RawFile
                    Next ZipCode
                    ExtractAgain TestPath & "\" & PassDir
                    GoTo NextPass
                Else
                    strFilename = ""
                    strFileInfo = "To extract this File you need to put the file STARLYNX.EXE into a folder on the PATH environment variable."
                    State = NotValid
                    GoTo NextPass
                End If
            End If
                    
            '=================
            'RAW FILES - PRG'S
            '=================
            
            .Pattern = "*.*"
            .Refresh
            If .ListCount > 0 Then
                TempFlag = False
                For ZipCode = 0 To .ListCount - 1
                    f = FreeFile()
                    Open TestPath & "\" & .List(ZipCode) For Binary As #f
                    FileLen = LOF(f)
                    Close #f
                    If FileLen < 51201 Then
                        TempFlag = True
                        If Func.DirExists(TestPath & "\" & PassDir) = False Then
                            MkDir TestPath & "\" & PassDir
                        End If
                        Name (TestPath & "\" & .List(ZipCode)) As (TestPath & "\" & PassDir & "\" & .List(ZipCode) & ".prg")
                    End If
                Next ZipCode
                If TempFlag = True Then
                    ExtractAgain TestPath & "\" & PassDir
                    GoTo NextPass
                End If

            End If
            
            '=========
            'NOT VALID
            '=========
            
            strFilename = ""
            If .ListCount = 0 Then
                strFileInfo = "This archive file is not compatible with gamebase64 or Quick64.  A resulting game-file has not been found."
            Else
                strFileInfo = "This archive file is not compatible with gamebase64 or Quick64." & vbCrLf & FillLine & vbCrLf & FilesInTempDIR(TestPath) & FillLine
            End If
            State = NotValid
            GoTo NextPass
            
        End With
        
    End If
    
Err_Handler:
    strFilename = ""
    strFileInfo = "An error was encountered while extracting this archive: " & vbCrLf & vbCrLf & Err.Description & "  (" & Trim$(Err.Number) & ")"
    State = NotValid
    GoTo NextPass
    
NextPass:
    
End Sub

Private Sub Zip2D64(ByVal strDestPath As String, ByVal strPath As String, ByVal strRawFile As String, ByVal strD64File As String)
    
    Dim sNull As String
    Dim sInfo As STARTUPINFO
    Dim pInfo As PROCESS_INFORMATION
    Dim ReturnValue As Long
    Dim CommandLine As String
    Dim ShortRawFilename As String

    ChDrive strPath
    ChDir strPath

    'Run ZIP2D64.EXE.
    With sInfo
        .cbReserved2 = 0
        .lpReserved2 = vbNull
        .dwFlags = STARTF_USESHOWWINDOW
        .wShowWindow = SW_HIDE
        .cb = Len(sInfo)
    End With
    CommandLine = CommandCom & "Zip2D64.exe" & " " & strRawFile & " " & Func.Long2Short(strDestPath) & "\" & "gbTemp.d64"
    ReturnValue = CreateProcess(sNull, CommandLine, ByVal 0&, ByVal 0&, 1&, NORMAL_PRIORITY_CLASS, ByVal 0&, sNull, sInfo, pInfo)
    ReturnValue = WaitForSingleObject(pInfo.hProcess, INFINITE)
    
    'rename
    If Func.FileExists(strDestPath & "\" & "gbTemp.d64", False, "") Then
        Name (strDestPath & "\" & "gbTemp.d64") As (strDestPath & "\" & strD64File)
    End If
    
End Sub
Private Sub UnLynx(ByVal strDestPath As String, ByVal strLynxPath As String, ByVal strLynxFile As String)
    
    Dim sNull As String
    Dim sInfo As STARTUPINFO
    Dim pInfo As PROCESS_INFORMATION
    Dim ReturnValue As Long
    Dim CommandLine As String
    Dim ShortRawFilename As String
    Dim DestFile As String
    Dim TempPath As String

    ShortRawFilename = Func.Long2Short(strLynxPath & "\" & strLynxFile)
    Func.GetFileAndPath ShortRawFilename, TempPath, DestFile
    DestFile = Left$(DestFile, Len(DestFile) - 4)

    ChDrive strLynxPath
    ChDir strLynxPath

    'Run STARLYNX.EXE.
    With sInfo
        .cbReserved2 = 0
        .lpReserved2 = vbNull
        .dwFlags = STARTF_USESHOWWINDOW
        .wShowWindow = SW_HIDE
        .cb = Len(sInfo)
    End With
    CommandLine = CommandCom & "starlynx.exe" & " -x " & ShortRawFilename & " /y " & Func.Long2Short(strDestPath) & "\" & DestFile
    ReturnValue = CreateProcess(sNull, CommandLine, ByVal 0&, ByVal 0&, 1&, NORMAL_PRIORITY_CLASS, ByVal 0&, sNull, sInfo, pInfo)
    ReturnValue = WaitForSingleObject(pInfo.hProcess, INFINITE)

End Sub


Private Sub UnLha(ByVal strPath As String, ByVal strFile As String, ByVal strDestPath As String)
    
    Dim sNull As String
    Dim sInfo As STARTUPINFO
    Dim pInfo As PROCESS_INFORMATION
    Dim ReturnValue As Long
    Dim CommandLine As String
    Dim ShortRawFilename As String
    Dim ShortDestPath As String
        
    'UnLHA to new Dir
    ChDrive strPath
    ChDir strPath
    
    'Run LHA.EXE.
    With sInfo
        .cbReserved2 = 0
        .lpReserved2 = vbNull
        .dwFlags = STARTF_USESHOWWINDOW
        .wShowWindow = SW_HIDE
        .cb = Len(sInfo)
    End With
    With Func
        ShortRawFilename = .Long2Short(strPath & "\" & strFile)
        ShortDestPath = .Long2Short(strDestPath)
    End With
    CommandLine = CommandCom & "lha.exe e /m " & ShortRawFilename & " " & ShortDestPath & "\"
    ReturnValue = CreateProcess(sNull, CommandLine, ByVal 0&, ByVal 0&, 1&, NORMAL_PRIORITY_CLASS, ByVal 0&, sNull, sInfo, pInfo)
    ReturnValue = WaitForSingleObject(pInfo.hProcess, INFINITE)

End Sub
Private Sub UnGZ(ByVal strPath As String, ByVal strFile As String, ByVal strDestPath As String)
    
    Dim sNull As String
    Dim sInfo As STARTUPINFO
    Dim pInfo As PROCESS_INFORMATION
    Dim ReturnValue As Long
    Dim CommandLine As String
    Dim ShortRawFilename As String
    Dim ShortDestPath As String
    Dim a As Long
        
    'UnGZ to same Dir
    ChDrive strPath
    ChDir strPath
    
    'Run GUNZIP.EXE.
    With sInfo
        .cbReserved2 = 0
        .lpReserved2 = vbNull
        .dwFlags = STARTF_USESHOWWINDOW
        .wShowWindow = SW_HIDE
        .cb = Len(sInfo)
    End With
    With Func
        ShortRawFilename = .Long2Short(strPath & "\" & strFile)
        ShortDestPath = .Long2Short(strDestPath)
    End With
    CommandLine = CommandCom & "gunzip.exe -f -q " & ShortRawFilename
    ReturnValue = CreateProcess(sNull, CommandLine, ByVal 0&, ByVal 0&, 1&, NORMAL_PRIORITY_CLASS, ByVal 0&, sNull, sInfo, pInfo)
    ReturnValue = WaitForSingleObject(pInfo.hProcess, INFINITE)
    
    'move file(s) to new dir - first delete all gz files
    With FileContents
        For a = 0 To .ListCount - 1
            Func.DeletePathSilent strPath & "\" & .List(a)
        Next a
        .Pattern = "*.*"
        .Refresh
        For a = 0 To .ListCount - 1
            Name (strPath & "\" & .List(a)) As (strDestPath & "\" & .List(a))
        Next a
    End With

End Sub

Private Sub WinzipExtract(ByVal strPath As String, ByVal strFile As String, ByVal strDestPath As String)
    
    Dim sNull As String
    Dim sInfo As STARTUPINFO
    Dim pInfo As PROCESS_INFORMATION
    Dim ReturnValue As Long
    Dim CommandLine As String
    Dim ShortRawFilename As String
    Dim ShortDestPath As String
    Dim a As Long
        
    'UnGZ to same Dir
    ChDrive strPath
    ChDir strPath
    
    'Run winzip32.EXE.
    With sInfo
        .cbReserved2 = 0
        .lpReserved2 = vbNull
        .dwFlags = STARTF_USESHOWWINDOW
        .wShowWindow = SW_MINIMIZE
        .cb = Len(sInfo)
    End With
    With Func
        ShortRawFilename = """" & strPath & "\" & strFile & """"
        ShortDestPath = """" & strDestPath & """"
    End With
    CommandLine = """" & WinZip & """ -e " & ShortRawFilename & " " & ShortDestPath
    ReturnValue = CreateProcess(sNull, CommandLine, ByVal 0&, ByVal 0&, 1&, NORMAL_PRIORITY_CLASS, ByVal 0&, sNull, sInfo, pInfo)
    ReturnValue = WaitForSingleObject(pInfo.hProcess, INFINITE)

End Sub
Private Function FilesInTempDIR(ByVal Directory As String) As String
    
    Dim ItemInList As Integer
    Dim TempFile As String
    
    FilesInTempDIR = ""
    TempFile = Dir(Directory & "\*.*")
    Do While TempFile <> ""
        FilesInTempDIR = FilesInTempDIR & TempFile & vbCrLf
        TempFile = Dir
    Loop
    
End Function
Private Sub MoveToRezipFolder(ByVal FromDir As String)

    Dim a As Integer

    With FileContents
        .Path = FromDir
        .Pattern = "*.*"
        .Refresh
        MkDir ReZipDir
        For a = 0 To .ListCount - 1
            Name (FromDir & "\" & .List(a)) As (ReZipDir & .List(a))
        Next a
        Func.DeletePathSilent FromDir
    End With

End Sub




Private Sub Class_Initialize()

    Set Func = New csFunctions
    Set FileContents = frmGB64Main.Files
    CommandCom = Func.Long2Short(Environ$("COMSPEC")) & " /c "

End Sub


Private Sub Class_Terminate()

    Set Func = Nothing
    Set FileContents = Nothing

End Sub


